import { RequestHandler } from 'msw';
import type { SetupWorkerApi } from 'msw/browser';
import type { SetupServerApi } from 'msw/node';
export type SetupApi = SetupWorkerApi | SetupServerApi;
export type InitializeOptions = Parameters<SetupWorkerApi['start']>[0] | Parameters<SetupServerApi['listen']>[0];
export type MswParameters = {
    msw?: RequestHandler[] | {
        handlers: RequestHandler[] | Record<string, RequestHandler>;
    };
};
type Context = {
    parameters: MswParameters;
};
export declare function initialize(options?: InitializeOptions, initialHandlers?: RequestHandler[]): SetupApi;
export declare function initializeWorker(options?: InitializeOptions): SetupApi;
export declare function getWorker(): SetupApi;
export declare const mswDecorator: <Story extends (...args: any[]) => any>(storyFn: Story, context: Context) => any;
export declare const mswLoader: (context: Context) => Promise<{}>;
export {};
